package com.qmth.teachcloud.eds.utils.gdpu;

import java.sql.*;
import java.util.List;

public class JdbcUtil {

    // MySQL8.0以下版本 - JDBC驱动名及数据库URL
    static final String JDBC_DRIVER = "com.mysql.cj.jdbc.Driver";
    // test为数据库名,?后面这句很重要,设置useSSl=false
    static final String DB_URL = "jdbc:mysql://dexchange.gdpu.edu.cn:3306/ZNKSPT?allowPublicKeyRetrieval=true&useSSL=false&serverTimezone=UTC&useUnicode=true&characterEncoding=utf8";
//    static final String DB_URL = "jdbc:mysql://localhost:3306/exchange-2.0.0?allowPublicKeyRetrieval=true&useSSL=false&serverTimezone=UTC&useUnicode=true&characterEncoding=utf8";

    // 数据库的用户名与密码，需要根据自己的设置
//    static final String USER = "root";
        static final String USER = "ZNKSPT";
//    static final String PASS = "12345678";
    static final String PASS = "GdxWs@169139958$";

    public static <T> List<T> query(String sql, Class<T> clazz) {
        Connection conn = null;
        Statement stmt = null;
        ResultSet rs = null;
        try {
            // 注册 JDBC 驱动,加载驱动
            Class.forName(JDBC_DRIVER);

            // 打开链接,连接数据库
            conn = DriverManager.getConnection(DB_URL, USER, PASS);
            System.out.println("数据库连接成功");

            // 执行查询
            stmt = conn.createStatement();
            System.out.println("实例化Statement对象成功");
            rs = stmt.executeQuery(sql);
            System.out.println("ResultSet对象返回成功");
            return ResultSetUtil.readList(rs, clazz);
        } catch (Exception e) {
            // 处理 Class.forName 错误
            e.printStackTrace();
            throw new RuntimeException(e.getMessage());
        } finally {
            // 完成后关闭
            try {
                rs.close();
            } catch (SQLException e) {
                throw new RuntimeException(e);
            }
            try {
                stmt.close();
            } catch (SQLException e) {
                throw new RuntimeException(e);
            }
            try {
                conn.close();
            } catch (SQLException e) {
                throw new RuntimeException(e);
            }
            // 关闭资源
            try {
                if (stmt != null) stmt.close();
            } catch (SQLException se2) {
            }// 什么都不做
            try {
                if (conn != null) conn.close();
            } catch (SQLException se) {
                se.printStackTrace();
            }
        }
    }
}
